Index: issm/trunk/src/c/classes/Elements/Element.h
===================================================================
--- issm/trunk/src/c/classes/Elements/Element.h	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/Element.h	(revision 18301)
@@ -47,4 +47,7 @@
 		Parameters  *parameters;
 
+		int* element_type_list;
+		int  element_type;
+
 	public: 
 		/*Constructors/Destructores*/
@@ -56,8 +59,12 @@
 		/* bool       AllActive(void); */
 		/* bool       AnyActive(void); */
+		void       ComputeNewDamage();
+		void       ComputeStrainRate();
 		void       CoordinateSystemTransform(IssmDouble** ptransform,Node** nodes,int numnodes,int* cs_array);
 		void       Echo();
 		void       DeepEcho();
 		void       DeleteMaterials(void);
+		void       dViscositydBSSA(IssmDouble* pdmudB,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input);
+		void       dViscositydDSSA(IssmDouble* pdmudB,int dim,IssmDouble* xyz_list,Gauss* gauss,Input* vx_input,Input* vy_input);
 		IssmDouble Divergence(void);
 		void       ThermalToEnthalpy(IssmDouble* penthalpy,IssmDouble temperature,IssmDouble waterfraction,IssmDouble pressure);
@@ -94,4 +101,5 @@
 		IssmDouble GetYcoord(IssmDouble* xyz_list,Gauss* gauss);
 		IssmDouble GetZcoord(IssmDouble* xyz_list,Gauss* gauss);
+		void       GradientIndexing(int* indexing,int control_index);
 		bool       HasNodeOnBase();
 		bool       HasNodeOnSurface();
@@ -107,4 +115,5 @@
 		bool	     IsInput(int name);
 		bool       IsFloating(); 
+		void       LinearFloatingiceMeltingRate(); 
 		ElementVector*  NewElementVector(int approximation_enum=NoneApproximationEnum);
 		ElementMatrix*  NewElementMatrix(int approximation_enum=NoneApproximationEnum);
@@ -156,4 +165,5 @@
 		virtual void       Configure(Elements* elements,Loads* loads,Nodes* nodes,Vertices* vertices,Materials* materials,Parameters* parameters)=0;
 		virtual void       SetCurrentConfiguration(Elements* elements,Loads* loads,Nodes* nodes,Materials* materials,Parameters* parameters)=0;
+		virtual void       ResetHooks()=0;
 		virtual void   ElementSizes(IssmDouble* phx,IssmDouble* phy,IssmDouble* phz)=0;
 
@@ -162,4 +172,5 @@
 		virtual void   NodalFunctions(IssmDouble* basis,Gauss* gauss)=0;
 		virtual void   NodalFunctionsP1(IssmDouble* basis,Gauss* gauss)=0;
+		virtual void   NodalFunctionsP2(IssmDouble* basis,Gauss* gauss)=0;
 		virtual void   NodalFunctionsVelocity(IssmDouble* basis, Gauss* gauss)=0;
 		virtual void   NodalFunctionsPressure(IssmDouble* basis, Gauss* gauss)=0;
@@ -184,4 +195,5 @@
 		virtual int    GetNodeIndex(Node* node)=0;
 		virtual int    GetNumberOfNodes(void)=0;
+		virtual int    GetNumberOfNodes(int enum_type)=0;
 		virtual int    GetNumberOfVertices(void)=0;
 
@@ -202,6 +214,4 @@
 		virtual void   ComputeSigmaNN(void)=0;
 		virtual void   ComputeBasalStress(Vector<IssmDouble>* sigma_b)=0;
-		virtual void   ComputeStrainRate()=0;
-		virtual void   ComputeStrainRate(Vector<IssmDouble>* eps)=0;
 		virtual void   ComputeStressTensor(void)=0;
 		virtual void   ComputeDeviatoricStressTensor(void)=0;
@@ -228,5 +238,4 @@
 		virtual void   PositiveDegreeDay(IssmDouble* pdds,IssmDouble* pds,IssmDouble signorm)=0;
 		virtual void   Delta18oParameterization(void)=0;
-		virtual void   SmbGradients(void)=0;
 	   virtual Element*   SpawnBasalElement(void)=0;
 		virtual Element*   SpawnTopElement(void)=0;
@@ -247,17 +256,7 @@
 		virtual void   ZeroLevelsetCoordinates(IssmDouble** pxyz_zero,IssmDouble* xyz_list,int levelsetenum)=0;
 		virtual void   GetIcefrontCoordinates(IssmDouble** pxyz_front,IssmDouble* xyz_list,int levelsetenum)=0;
+		virtual void   GetLevelCoordinates(IssmDouble** pxyz_front,IssmDouble* xyz_list,int levelsetenum,IssmDouble level)=0;
 
 		virtual void   AverageOntoPartition(Vector<IssmDouble>* partition_contributions,Vector<IssmDouble>* partition_areas,IssmDouble* vertex_response,IssmDouble* qmu_part)=0;
-		virtual void   MinVel(IssmDouble* pminvel)=0;
-		virtual void   MaxVel(IssmDouble* pmaxvel)=0;
-		virtual void   MinVx(IssmDouble* pminvx)=0;
-		virtual void   MaxVx(IssmDouble* pmaxvx)=0;
-		virtual void   MaxAbsVx(IssmDouble* pmaxabsvx)=0;
-		virtual void   MinVy(IssmDouble* pminvy)=0;
-		virtual void   MaxVy(IssmDouble* pmaxvy)=0;
-		virtual void   MaxAbsVy(IssmDouble* pmaxabsvy)=0;
-		virtual void   MinVz(IssmDouble* pminvz)=0;
-		virtual void   MaxVz(IssmDouble* pmaxvz)=0;
-		virtual void   MaxAbsVz(IssmDouble* pmaxabsvz)=0;
 		virtual IssmDouble MassFlux(IssmDouble* segment)=0;
 		virtual IssmDouble MassFlux(IssmDouble x1,IssmDouble y1, IssmDouble x2, IssmDouble y2,int segment_id)=0;
@@ -275,8 +274,5 @@
 		#endif
 
-		virtual void   Gradj(Vector<IssmDouble>* gradient,int control_type,int control_index)=0;
-		virtual void   ControlInputGetGradient(Vector<IssmDouble>* gradient,int enum_type,int control_index)=0;
 		virtual void   ControlInputSetGradient(IssmDouble* gradient,int enum_type,int control_index)=0;
-		virtual void   ControlInputScaleGradient(int enum_type, IssmDouble scale)=0;
 		virtual void   ControlToVectors(Vector<IssmPDouble>* vector_control, Vector<IssmPDouble>* vector_gradient,int control_enum)=0;
 		virtual void   GetVectorFromControlInputs(Vector<IssmDouble>* gradient,int control_enum,int control_index,const char* data)=0;
Index: issm/trunk/src/c/classes/Elements/ElementHook.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/ElementHook.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/ElementHook.cpp	(revision 18301)
@@ -27,10 +27,10 @@
 ElementHook::~ElementHook(){/*{{{*/
 
-	int i;
-
-	for(i=0;i<this->numanalyses;i++){
-		if (this->hnodes[i]) delete this->hnodes[i];
+	if(this->hnodes){
+		for(int i=0;i<this->numanalyses;i++){
+			if(this->hnodes[i]) delete this->hnodes[i]; 
+		}
+		delete [] this->hnodes;
 	}
-	delete [] this->hnodes;
 	delete hvertices;
 	delete hmaterial;
@@ -76,5 +76,5 @@
 
 void ElementHook::SetHookNodes(int* node_ids,int numnodes,int analysis_counter){/*{{{*/
-	this->hnodes[analysis_counter]= new Hook(node_ids,numnodes);
+	if(this->hnodes) this->hnodes[analysis_counter]= new Hook(node_ids,numnodes);
 }
 /*}}}*/
Index: issm/trunk/src/c/classes/Elements/Elements.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/Elements.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/Elements.cpp	(revision 18301)
@@ -62,4 +62,18 @@
 }
 /*}}}*/
+void Elements::ResetHooks(){/*{{{*/
+
+	vector<Object*>::iterator object;
+	Element* element=NULL;
+
+	for ( object=objects.begin() ; object < objects.end(); object++ ){
+
+		element=dynamic_cast<Element*>((*object));
+		element->ResetHooks();
+
+	}
+
+}
+/*}}}*/
 int  Elements::MaxNumNodes(void){/*{{{*/
 
Index: issm/trunk/src/c/classes/Elements/Elements.h
===================================================================
--- issm/trunk/src/c/classes/Elements/Elements.h	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/Elements.h	(revision 18301)
@@ -27,4 +27,5 @@
 		int    MaxNumNodes(void);
 		void   SetCurrentConfiguration(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
+		void   ResetHooks();
 		int    NumberOfElements(void);
 		void   InputDuplicate(int input_enum,int output_enum);
